//////////////////////////////////////////////////////////////////////////////
//
// @descr    Main Viewer
//
// @short    Main Viewer
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////
#ifndef __NL_MAIN_DLG_H__
#define __NL_MAIN_DLG_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////

// SystemDLL
#include <nlObserver.h>
#include <nlCommonType.h>

// Local
#include "Resource.h"

//////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
//////////////////////////////////////////////////////////////////////////////
class CnlClientInterface;

//////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
//////////////////////////////////////////////////////////////////////////////
class CMainDlg : public CDialog, public CnlObserver
{
  public:
    //1 Final
    // @descr  Constructor
    // @param  pNetworkModel  IN: Handle to the model to observe
    // @param  pParent  IN: Handle to the parent dialog
    // @end
    explicit CMainDlg(
      CnlClientInterface* const pClientInterface,
      CWnd* pParent = NULL );

    // @descr  Destructor
    // @end
    virtual ~CMainDlg();

    //2 From CnlObserver
    void Update(
      CnlModel* const,
      const int );
    void StopObserving(
      CnlModel* const );
      
    // Dialog Data
    //{{AFX_DATA(CMainDlg)
    enum { IDD = IDD_DIALOG_SMALL_NETWORK };
    //}}AFX_DATA

  protected:

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CMainDlg)
    virtual BOOL OnInitDialog();
    virtual void DoDataExchange(CDataExchange* pDX);// DDX/DDV support
    virtual void OnOK();
    virtual void OnCancel();
    //}}AFX_VIRTUAL
    
    HICON m_hIcon;

    // Generated message map functions
    //{{AFX_MSG(CMainDlg)
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    afx_msg void OnDestroy();
    afx_msg void OnPaint();
    afx_msg HCURSOR OnQueryDragIcon();
    afx_msg void OnButtonEndMachineA();
    afx_msg void OnButtonEndMachineB();
    afx_msg void OnButtonEndMachineC();
    afx_msg void OnButtonEndMachineD();
    afx_msg void OnButtonEndMachineE();
    afx_msg void OnButtonEndMachineF();
    afx_msg void OnButtonEndMachineG();
    afx_msg void OnButtonEndMachineH();
    afx_msg void OnButtonEndMachineI();
    afx_msg void OnButtonEndMachineJ();
    afx_msg void OnButtonEndMachineK();
    afx_msg void OnButtonEndMachineL();
    afx_msg void OnButtonRouter();
    afx_msg void OnButtonStep();
    afx_msg void OnButtonFinish();
    afx_msg void OnButtonTest();
    afx_msg void OnSelchangeComboLayerFilter();
    afx_msg void OnCheckEventSend();
    afx_msg void OnCheckEventReceiveAccept();
   afx_msg void OnSelchangeListPofMessage();
    //}}AFX_MSG

    DECLARE_MESSAGE_MAP()
    
    //{{AFX_INSERT_LOCATION}}
    // Microsoft Visual C++ will insert additional declarations immediately before the previous line.

  private:

    //1 Implementation
    struct SnlImp;
    SnlImp* m_pImp;
    SnlImp* Imp();
    const SnlImp* Imp() const;
    friend SnlImp;

    //1 Unimplemented
    CMainDlg( const CMainDlg& );
    CMainDlg& operator=( const CMainDlg& );
};

#endif
