///////////////////////////////////////////////////////////////////////////////
//
// @descr   Used for command run control
//
// @short   Used for command run control
//
// @author  Jim Carole
//
// @end
//
///////////////////////////////////////////////////////////////////////////////
#ifndef __nl_MFC_THREAD_H__
#define __nl_MFC_THREAD_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

///////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
///////////////////////////////////////////////////////////////////////////////
//#include "nlKernel.h"

///////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
///////////////////////////////////////////////////////////////////////////////
struct SnlMfcThreadImp;
class  CnlWinThread;
class  CnlThreadHandler;

///////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
///////////////////////////////////////////////////////////////////////////////

class CnlMfcThread
{
  public:

    // @descr  default constructor
    // @end
    CnlMfcThread( 
      CnlThreadHandler* pThreadHandler,
      unsigned __int32 nInitFlnls = 0,
      LPSECURITY_ATTRIBUTES pSecurityAttributes = 0,
      unsigned __int32 nStackSize = 0 );

    // @descr  destructor
    // @end
    virtual ~CnlMfcThread();

  public:

    virtual BOOL    InitInstance( );
    virtual int     ExitInstance();
    virtual int     Run();

    // @descr  get the internal handle
    // @return
    // @end
    virtual HANDLE GetHandle() const;

  protected:

    // @descr
    // @param  hHandle
    // @end
    void SetHandle( HANDLE hHandle );

    // @descr
    // @param  nStatus
    // @end
    void SetStatus( __int32 nStatus );

    // @descr
    // @return CnlWinThread* -
    // @end
    CnlWinThread* GetWinThread() const;

    CnlThreadHandler* GetThreadHandler() const;

  private:

    //1 Implementation
    struct SnlImp;
    SnlImp* m_pImp;
    SnlImp* Imp();
    const SnlImp* Imp() const;
    friend SnlImp;

    //1 Unimplemented
    CnlMfcThread( const CnlMfcThread& );
    CnlMfcThread& operator=( const CnlMfcThread& );
    CnlMfcThread* operator&();
    const CnlMfcThread* operator&() const;
};

#endif
