/////////////////////////////////////////////////////////////////////////////
//
// @descr    See nlObserver.h
//
// @short    See nlObserver.h
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

//1 External
//2 From

//1 Local
#include "nlObserver.h"

///////////////////////////////////////////////////////////////////////////////
//
// Global Variables and Namespace Declarations
//
///////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///////////////////////////////////////////////////////////////////////////////
//
// File Local
//
///////////////////////////////////////////////////////////////////////////////
namespace
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Private Implementation
//
///////////////////////////////////////////////////////////////////////////////
inline        CnlObserver::SnlImp* CnlObserver::Imp()       { return m_pImp; }
inline const  CnlObserver::SnlImp* CnlObserver::Imp() const { return m_pImp; }

struct CnlObserver::SnlImp
{
  //1 Function Prototypes
  
  // Constructor
  SnlImp(
    CnlObserver* const pOwner );

  // Destructor
   ~SnlImp();

  //1 Handles (Never 'new' or 'delete')

  // Handle to the object that owns this implementation
  CnlObserver* const m_pOwner;

  //1 Coordinated Data (Responsible for either 'new' or 'delete')

  // Desc

  //1 Owned Data (Responsible for both 'new' and 'delete')

  // Desc

private:

  // Unimplemented
  SnlImp( const SnlImp& );
  SnlImp& operator=( const SnlImp& );
  SnlImp* operator&();
  const SnlImp* operator&() const;
};

//1 Function Definitions

///////////////////////////////////////////////////////////////////////////////
CnlObserver::SnlImp::SnlImp(
  CnlObserver* const pOwner )
 :
  m_pOwner( pOwner )
{
}

///////////////////////////////////////////////////////////////////////////////
CnlObserver::SnlImp::~SnlImp()
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Static Member Initialization
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Public/Protected Implementation
//
///////////////////////////////////////////////////////////////////////////////
CnlObserver::CnlObserver()
{
  m_pImp = new SnlImp( this );
}

///////////////////////////////////////////////////////////////////////////////
CnlObserver::~CnlObserver()
{
  delete m_pImp;
}

///////////////////////////////////////////////////////////////////////////////
void CnlObserver::Initialize()
{
}

///////////////////////////////////////////////////////////////////////////////
void CnlObserver::PreDestroy()
{
}


