///////////////////////////////////////////////////////////////////////////////
//
// @descr    Encapsulates the thread procedure for a thread object
//
// @short    Encapsulates the thread procedure for a thread object
//
// @author   Jim Carole
//
// @end
//
///////////////////////////////////////////////////////////////////////////////
#ifndef __nl_THREAD_HANDLER_H__
#define __nl_THREAD_HANDLER_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

///////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
///////////////////////////////////////////////////////////////////////////////

class CnlThreadHandler
{
  public: // Constructor(s) & Destructor

    // @descr  destructor
    // @end
    virtual ~CnlThreadHandler();

 public:

    // @descr  this is a pure virtual function and it must be implemented
    //         in a derived class. The "this" object inside ThreadHandlerProc()
    //         will be the CnlThreadHandler derived object itself.
    // @return __int32 - exit code of the thread when finished
    // @end
   virtual unsigned __int32 ThreadHandlerProc() = 0;
};

#endif
