///////////////////////////////////////////////////////////////////////////////
//
// @descr  Windows thread
//
// @short  Windows thread
//
// @author  Jim Carole
//
// @end
//
///////////////////////////////////////////////////////////////////////////////
#ifndef __nl_WIN_THREAD_H__
#define __nl_WIN_THREAD_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

///////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
///////////////////////////////////////////////////////////////////////////////
struct SnlWinThreadImp;
class  CnlMfcThread;

///////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
///////////////////////////////////////////////////////////////////////////////

class CnlWinThread : public CWinThread
{
  public: // Constructor(s) & Destructor

    // @descr  initialization construction
    // @param  pMfcThread  owner of the thread
    // @end
    CnlWinThread( 
      CnlMfcThread* pMfcThread );

    // @descr  destructor
    // @end
    virtual ~CnlWinThread();

  public:

    virtual BOOL    InitInstance( );
    virtual int     ExitInstance();
    virtual int     Run();

  protected:
    
    virtual BOOL    MfcInitInstance( );
    virtual int     MfcExitInstance();
    virtual int     MfcRun();

  private:

    friend class CnlMfcThread;

    //1 Implementation
    struct SnlImp;
    SnlImp* m_pImp;
    SnlImp* Imp();
    const SnlImp* Imp() const;
    friend SnlImp;

    //1 Unimplemented
    CnlWinThread( const CnlWinThread& );
    CnlWinThread& operator=( const CnlWinThread& );
    CnlWinThread* operator&();
    const CnlWinThread* operator&() const;
};

#endif
