/////////////////////////////////////////////////////////////////////////////
//
// @descr    See nlCommand.h
//
// @short    See nlCommand.h
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

//1 External
//2 From 

//1 Local
#include "nlCommand.h"

///////////////////////////////////////////////////////////////////////////////
//
// Global Variables and Namespace Declarations
//
///////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace NnlSystemMgrType;

///////////////////////////////////////////////////////////////////////////////
//
// File Local
//
///////////////////////////////////////////////////////////////////////////////
namespace
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Private Implementation
//
///////////////////////////////////////////////////////////////////////////////
inline        CnlCommand::SnlImp* CnlCommand::Imp()       { return m_pImp; }
inline const  CnlCommand::SnlImp* CnlCommand::Imp() const { return m_pImp; }

struct CnlCommand::SnlImp
{
  //1 Function Prototypes
  
  // Constructor
  SnlImp(
    CnlCommand* const pOwner,
      const NnlSystemMgrType::EnlCommand eType );

  // Destructor
   ~SnlImp();

  //1 Handles (Never 'new' or 'delete')

  // The object that owns this implementation
  CnlCommand* const m_pOwner;

  //1 Coordinated Data (Responsible for either 'new' or 'delete')

  // Desc

  //1 Owned Data (Responsible for both 'new' and 'delete')

  // The type command I am carrying
  const NnlSystemMgrType::EnlCommand m_eType;

private:

  //1 Unimplemented
  SnlImp( const SnlImp& );
  SnlImp& operator=( const SnlImp& );
  SnlImp* operator&();
  const SnlImp* operator&() const;
};

//1 Function Definitions

///////////////////////////////////////////////////////////////////////////////
CnlCommand::SnlImp::SnlImp(
  CnlCommand* const pOwner,
  const NnlSystemMgrType::EnlCommand eType )
 :
  m_pOwner( pOwner ),
  m_eType( eType )
{
}

///////////////////////////////////////////////////////////////////////////////
CnlCommand::SnlImp::~SnlImp()
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Static Member Initialization
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Public/Protected Implementation
//
///////////////////////////////////////////////////////////////////////////////
CnlCommand::CnlCommand(
  const NnlSystemMgrType::EnlCommand eType )
{
  m_pImp = new SnlImp( this, eType );
}

///////////////////////////////////////////////////////////////////////////////
CnlCommand::~CnlCommand()
{
  delete m_pImp;
}

///////////////////////////////////////////////////////////////////////////////
EnlCommand CnlCommand::GetType() const
{
  return Imp()->m_eType;
}

///////////////////////////////////////////////////////////////////////////////
CnlVariableParmContainer CnlCommand::GetParms() const
{
  return *this;
}

///////////////////////////////////////////////////////////////////////////////
void CnlCommand::Dump() const
{
  TRACE0( _T( "\nCommand Dump:" ) );
  TRACE1( _T( "\nType:%d" ), Imp()->m_eType );

  CnlVariableParmContainer::Dump();
}

