//////////////////////////////////////////////////////////////////////////////
//
// @descr    Composite pattern "Component" base class
//
// @short    Composite pattern "Component" base class
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////
#ifndef __NL_NETWORK_COMPONENT_H__
#define __NL_NETWORK_COMPONENT_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////

// From 

// Local

//////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
//////////////////////////////////////////////////////////////////////////////
class CnlNetworkComponent
{
  public:
    //1 Final
    // @descr  Constructor
    // @end
    explicit CnlNetworkComponent();

    // @descr  Post-constructor initialization
    // @end
    void Initialize();

    // @descr  Pre-Destructor cleanup
    // @end
    void PreDestroy();

    //2 From Cnl
    
    //1 Virtual
    // @descr  Destructor
    // @end
    virtual ~CnlNetworkComponent();

    //2 From Cnl

    //1 Abstract

    //2 From Cnl

  protected:

  private:

    //1 Implementation
    struct SnlImp;
    SnlImp* m_pImp;
    SnlImp* Imp();
    const SnlImp* Imp() const;
    friend SnlImp;

    //1 Unimplemented
    CnlNetworkComponent( const CnlNetworkComponent& );
    CnlNetworkComponent& operator=( const CnlNetworkComponent& );
    CnlNetworkComponent* operator&();
    const CnlNetworkComponent* operator&() const;
};

#endif

