/////////////////////////////////////////////////////////////////////////////
//
// @descr    Composite pattern "Composite" base class
//
// @short    Composite pattern "Composite" base class
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

//1 External
//2 From

//1 Local
#include "nlNetworkComposite.h"

///////////////////////////////////////////////////////////////////////////////
//
// Global Variables and Namespace Declarations
//
///////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//using namespace xx;

///////////////////////////////////////////////////////////////////////////////
//
// File Local
//
///////////////////////////////////////////////////////////////////////////////
namespace
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Private Implementation
//
///////////////////////////////////////////////////////////////////////////////
inline        CnlNetworkComposite::SnlImp* CnlNetworkComposite::Imp()       { return m_pImp; }
inline const  CnlNetworkComposite::SnlImp* CnlNetworkComposite::Imp() const { return m_pImp; }

struct CnlNetworkComposite::SnlImp
{
  //1 Function Prototypes
  
  // Constructor
  SnlImp(
    CnlNetworkComposite* const pOwner );

  // Destructor
   ~SnlImp();

  //1 Handles (Never 'new' or 'delete')

  // Handle to the object that owns this implementation
  CnlNetworkComposite* const m_pOwner;

  //1 Coordinated Data (Responsible for either 'new' or 'delete')

  // Desc

  //1 Owned Data (Responsible for both 'new' and 'delete')

  // Desc

private:

  // Unimplemented
  SnlImp( const SnlImp& );
  SnlImp& operator=( const SnlImp& );
  SnlImp* operator&();
  const SnlImp* operator&() const;
};

//1 Function Definitions

///////////////////////////////////////////////////////////////////////////////
CnlNetworkComposite::SnlImp::SnlImp(
  CnlNetworkComposite* const pOwner )
 :
  m_pOwner( pOwner )
{
}

///////////////////////////////////////////////////////////////////////////////
CnlNetworkComposite::SnlImp::~SnlImp()
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Static Member Initialization
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Public/Protected Implementation
//
///////////////////////////////////////////////////////////////////////////////
CnlNetworkComposite::CnlNetworkComposite()
{
  m_pImp = new SnlImp( this );
}

///////////////////////////////////////////////////////////////////////////////
CnlNetworkComposite::~CnlNetworkComposite()
{
  delete m_pImp;
}

///////////////////////////////////////////////////////////////////////////////
void CnlNetworkComposite::Initialize()
{
}

///////////////////////////////////////////////////////////////////////////////
void CnlNetworkComposite::PreDestroy()
{
}


