//////////////////////////////////////////////////////////////////////////////
//
// @descr    Composite pattern "Composite" base class
//
// @short    Composite pattern "Composite" base class
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////
#ifndef __NL_NETWORK_COMPOsITE_H__
#define __NL_NETWORK_COMPOsITE_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////

// From 

// Local
#include "nlNetworkComponent.h"

//////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
//////////////////////////////////////////////////////////////////////////////
class CnlNetworkComposite : public CnlNetworkComponent
{
  public:
    //1 Final
    // @descr  Constructor
    // @end
    explicit CnlNetworkComposite();

    // @descr  Post-constructor initialization
    // @end
    void Initialize();

    // @descr  Pre-Destructor cleanup
    // @end
    void PreDestroy();

    //2 From Cnl
    
    //1 Virtual
    // @descr  Destructor
    // @end
    virtual ~CnlNetworkComposite();

    //2 From Cnl

    //1 Abstract

    //2 From Cnl

  protected:

  private:

    //1 Implementation
    struct SnlImp;
    SnlImp* m_pImp;
    SnlImp* Imp();
    const SnlImp* Imp() const;
    friend SnlImp;

    //1 Unimplemented
    CnlNetworkComposite( const CnlNetworkComposite& );
    CnlNetworkComposite& operator=( const CnlNetworkComposite& );
    CnlNetworkComposite* operator&();
    const CnlNetworkComposite* operator&() const;
};

#endif

