//////////////////////////////////////////////////////////////////////////////
//
// @descr    Composite pattern "Leaf" base class
//
// @short    Composite pattern "Leaf" base class
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////
#ifndef __NL_NETWORK_LEAF_H__
#define __NL_NETWORK_LEAF_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////

// From 

// Local
#include "nlNetworkComponent.h"

//////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
//////////////////////////////////////////////////////////////////////////////
class CnlNetworkLeaf : public CnlNetworkComponent
{
  public:
    //1 Final
    // @descr  Constructor
    // @end
    explicit CnlNetworkLeaf();

    // @descr  Post-constructor initialization
    // @end
    void Initialize();

    // @descr  Pre-Destructor cleanup
    // @end
    void PreDestroy();

    //2 From Cnl
    
    //1 Virtual
    // @descr  Destructor
    // @end
    virtual ~CnlNetworkLeaf();

    //2 From Cnl

    //1 Abstract

    //2 From Cnl

  protected:

  private:

    //1 Implementation
    struct SnlImp;
    SnlImp* m_pImp;
    SnlImp* Imp();
    const SnlImp* Imp() const;
    friend SnlImp;

    //1 Unimplemented
    CnlNetworkLeaf( const CnlNetworkLeaf& );
    CnlNetworkLeaf& operator=( const CnlNetworkLeaf& );
    CnlNetworkLeaf* operator&();
    const CnlNetworkLeaf* operator&() const;
};

#endif

