/////////////////////////////////////////////////////////////////////////////
//
// @descr    A network traffic router
//
// @short    A network traffic router
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

//1 External
//2 From

//1 Local
#include "nlRouter.h"

///////////////////////////////////////////////////////////////////////////////
//
// Global Variables and Namespace Declarations
//
///////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//using namespace xx;

///////////////////////////////////////////////////////////////////////////////
//
// File Local
//
///////////////////////////////////////////////////////////////////////////////
namespace
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Private Implementation
//
///////////////////////////////////////////////////////////////////////////////
inline        CnlRouter::SnlImp* CnlRouter::Imp()       { return m_pImp; }
inline const  CnlRouter::SnlImp* CnlRouter::Imp() const { return m_pImp; }

struct CnlRouter::SnlImp
{
  //1 Function Prototypes
  
  // Constructor
  SnlImp(
    CnlRouter* const pOwner );

  // Destructor
   ~SnlImp();

  //1 Handles (Never 'new' or 'delete')

  // Handle to the object that owns this implementation
  CnlRouter* const m_pOwner;

  //1 Coordinated Data (Responsible for either 'new' or 'delete')

  // Desc

  //1 Owned Data (Responsible for both 'new' and 'delete')

  // Desc

private:

  // Unimplemented
  SnlImp( const SnlImp& );
  SnlImp& operator=( const SnlImp& );
  SnlImp* operator&();
  const SnlImp* operator&() const;
};

//1 Function Definitions

///////////////////////////////////////////////////////////////////////////////
CnlRouter::SnlImp::SnlImp(
  CnlRouter* const pOwner )
 :
  m_pOwner( pOwner )
{
}

///////////////////////////////////////////////////////////////////////////////
CnlRouter::SnlImp::~SnlImp()
{
}

///////////////////////////////////////////////////////////////////////////////
//
// Static Member Initialization
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//
// Public/Protected Implementation
//
///////////////////////////////////////////////////////////////////////////////
CnlRouter::CnlRouter()
{
  m_pImp = new SnlImp( this );
}

///////////////////////////////////////////////////////////////////////////////
CnlRouter::~CnlRouter()
{
  delete m_pImp;
}

///////////////////////////////////////////////////////////////////////////////
void CnlRouter::Initialize()
{
}

///////////////////////////////////////////////////////////////////////////////
void CnlRouter::PreDestroy()
{
}


