//////////////////////////////////////////////////////////////////////////////
//
// @descr    The UDP software module
//
// @short    The UDP software module
//
// @author   Jim Carole 
//
// @end
//
//////////////////////////////////////////////////////////////////////////////
#ifndef __NL_UDP_MODULE_H__
#define __NL_UDP_MODULE_H__

///////////////////////////////////////////////////////////////////////////////
//
// Compiler & Linker Directives
//
///////////////////////////////////////////////////////////////////////////////
#pragma once

//////////////////////////////////////////////////////////////////////////////
//
// Include Files
//
//////////////////////////////////////////////////////////////////////////////

//1 External
//2 From 

//1 Local
#include "nlTransportLayerInterface.h"

//////////////////////////////////////////////////////////////////////////////
//
// Forward Declarations
//
//////////////////////////////////////////////////////////////////////////////
class CnlProcessInterface;
class CnlOs;

//////////////////////////////////////////////////////////////////////////////
//
// Definitions
//
//////////////////////////////////////////////////////////////////////////////
class CnlUdpModule : public CnlTransportLayerInterface
{
  public:
    //1 Final
    // @descr  Constructor
    // @param  pOs  IN: The operating system core
    // @end
    CnlUdpModule(
      CnlOs* const pOs );

    // @descr  Post-constructor initialization
    // @end
    void Initialize(
      CnlNetworkLayerInterface* const );

    // @descr  Pre-Destructor cleanup
    // @end
    void PreDestroy();
    
    //2 From CnlTransportLayerInterface
    void Broadcast(
      const int,
      const CnlVariableParmContainer& );
    void SendToIpAddress(
      const int,
      const CnlVariableParmContainer&,
      const CString );
    void ReceiveSegment(
      const CnlSegment& );

    //1 Virtual
    // @descr  Destructor
    // @end
    virtual ~CnlUdpModule();

    //2 From Cnl

    //1 Abstract

    //2 From Cnl

  protected:

  private:

    //1 Implementation
    struct SnlImp;
    SnlImp* m_pImp;
    SnlImp* Imp();
    const SnlImp* Imp() const;
    friend SnlImp;

    //1 Unimplemented
    CnlUdpModule( const CnlUdpModule& );
    CnlUdpModule& operator=( const CnlUdpModule& );
    CnlUdpModule* operator&();
    const CnlUdpModule* operator&() const;
};

#endif

